Insteon - Feature #930

iMeter Power Usage
12/17/2014 10:56 PM - Luke Murphey

Status: New Start date: 12/17/2014

Priority: Normal Due date:

Assignee: Luke Murphey % Done: 0%

Category: Estimated time: 0.00 hour

Target version: 0.10

Description

See https://github.com/automategreen/home-controller/blob/master/lib/Insteon/Meter.js

Related issues:

Related to Insteon Control - Feature #878: Allow controlling of Insteon in Sp... Closed 12/19/2015

History

#1 - 12/27/2014 07:30 AM - Luke Murphey

- Target version set to 0.6

#2 - 04/11/2015 12:39 AM - Luke Murphey

- Target version changed from 0.6 to 0.9

#3 - 06/04/2015 05:48 PM - Luke Murphey

- File eve-energy-device-app-icons.jpg added
https://github.com/automategreen/home-controller/blob/master/lib/Insteon/Meter.js
#4 - 12/19/2015 04:15 AM - Luke Murphey
- Related to Feature #878: Allow controlling of Insteon in Splunk added

#5 - 12/19/2015 07:03 PM - Luke Murphey

See also:

e http://cache.insteon.com/developer/2448A2dev-042011-en.pdf
e http://cache.insteon.com/developer/2423A1dev-072013-en.pdf

Basically, it looks like the iMeter needs to get a 00 82 command in order to send power readings.

#6 - 12/22/2015 07:30 AM - Luke Murphey
http://cache.insteon.com/developer/2423A1dev-072013-en.pdf

bytes 7 & 8 are power
bytes 9-12 are accumulated energy

IntEnergy = 256*256*256*Data9 + 256*256*Datal0 + 256*Datall + Datal2;
if (Data9 < 254)

AccumEnergy = IntEnergy * 65535.0 / (1000 * 60.0 * 60.0 * 60.0);
else

AccumEnergy = 0.0;
IntPwr = (Data7 << 8) | Data8;
*pwr = (double) IntPwr;

if (*pwr > 32767.0)
*pwr = *pwr - 65535.0;

#7 - 02/02/2016 03:15 AM - Luke Murphey

- Target version changed from 0.9 to 0.10

#8 - 04/17/2017 08:17 PM - Luke Murphey

See also:

https://github.com/openhab/openhab1-addons/blob/0d13cc0761633efd7998f89bca31e6887403490a/bundles/binding/org.openhab.binding.insteonplm
[src/main/java/org/openhab/binding/insteonplm/internal/device/MessageHandler.java

public void handleMessage (int group, byte cmdl, Msg msg, DeviceFeature f, String fromPort) {
if (msg.isExtended()) {
try {
http://cache.insteon.com/developer/2448A2dev-042011-en.pdf
http://cache.insteon.com/developer/2423A1dev-072013-en.pdf
http://cache.insteon.com/developer/2423A1dev-072013-en.pdf
https://github.com/openhab/openhab1-addons/blob/0d13cc0761633efd7998f89bca31e6887403490a/bundles/binding/org.openhab.binding.insteonplm/src/main/java/org/openhab/binding/insteonplm/internal/device/MessageHandler.java
https://github.com/openhab/openhab1-addons/blob/0d13cc0761633efd7998f89bca31e6887403490a/bundles/binding/org.openhab.binding.insteonplm/src/main/java/org/openhab/binding/insteonplm/internal/device/MessageHandler.java

// see iMeter developer notes 2423Aldev-072013-en.pdf

int b7 = msg.getByte ("userData7") & Oxff;
int b8 = msg.getByte ("userData8") & Oxff;

int watts = (b7 << 8) | b8;
if (watts > 32767) {
watts —-= 65535;

int b9 = msg.getByte ("userDatad9") & Oxff;

int bl0 = msg.getByte ("userDatallO") & Oxff;

int bll = msg.getByte ("userDatall") & Oxff;
)

RoundingMode .HAL

watts, kwh);
"kwh" ) ,.

"field", "watts");

int bl2 = msg.getByte("userDatal2") & Oxff;
BigDecimal kwh = BigDecimal.ZERO;
if (b9 < 254) {
int e = (b9 << 24) | (b1l0 << 16) | (bll << 8) | bl2;
kwh = new BigDecimal (e * 65535.0 / (1000 * 60 * 60 * 60)).setScale (4,
F_UP);
}
logger.debug("{}:{} watts: {} kwh: {} ", nm(), f.getDevice().getAddress(),
m_feature.publish (new DecimalType (kwh), StateChangeType.CHANGED,
m_feature.publish (new DecimalType (watts), StateChangeType.CHANGED,
} catch (FieldException e) {
logger.error ("error parsing {}: ", msg, e);
}
}
